#define RS LATB4
#define EN LATB3
unsigned char bufr[10];
/*-----------------LCD BEGIN----------------------------*/
void LCD_STROBE(void)
{
    EN = 1;					// SET ENABLE BIT
    __delay_us(0.5);
    EN = 0;					// CLEAR ENABLE BIT
}
/* FUNCTION TO DISPLAY A CHAR TO LCD */ 
void data(unsigned char c)
{
    RS = 1;
    __delay_us(40);
    PORTD = (c >> 4);
    LCD_STROBE();
    PORTD = (c);
    LCD_STROBE();
}
/* FUNCTION TO SEND A COMMAND TO LCD */
void cmd(unsigned char c)
{
    RS = 0;
    __delay_us(40);
    PORTD = (c >> 4);
    LCD_STROBE();
    PORTD = (c);
    LCD_STROBE();
}
/* FUNCTION TO CLEAR LCD */
void clear(void)
{
    cmd(0x01);
    __delay_ms(2);
}
/* INITIALIZE LCD MODULE */ 
void lcd_init()
{
    __delay_ms(20);
    cmd(0x30);
    __delay_ms(1);
    cmd(0x30);
    __delay_ms(1);
    cmd(0x30);
    cmd(0x28);            // Function set (4-bit interface, 2 lines, 5*7Pixels)
    cmd(0x28);            // Function set (4-bit interface, 2 lines, 5*7Pixels)
    cmd(0x28);            // Function set (4-bit interface, 2 lines, 5*7Pixels)
    cmd(0x0c);            // Make cursorinvisible
    clear();
    clear();			  // Clear screen
    cmd(0x6);             // Set entry Mode
}
/* FUNCTION TO DISPLAY A STRING */ 
void string(const char *q)
{
    while (*q) {
        data(*q++);
    }
}
/*-----------------------LCD END--------------------*/


/** FUNCTION TO CONVRT INT TO STRING **/
char *int_to_string(long int i, unsigned char* bufr)
{
     unsigned char temp_var;
	 unsigned char s = 0,t = 0;
	 if(i!=0)
	 {
	 while(i)
	 { 
        bufr[s++] = i % 10 + 0x30;
		i/=10;
	 }
	 bufr[s]=0;
	 s-=1;
	 for(;t<s;t++,s--)
	 {
		temp_var = bufr[s];
		bufr[s]=bufr[t];
		bufr[t]=temp_var;
	 }
	 }
	 else if(i==0)
	 {
		bufr[0]='0';
		bufr[1]='0';
	 }
	 return bufr;
}
/** FUNCTION TO CONVRT INT TO STRING **/
long int string_to_int(const char strng[]) 
{
	unsigned int i = 0x00;
	long int num = 0x0000;
	for (i = 0; strng[i] != '\0'; i++) 
    { 
		if(strng[i]=='.')i=i+1;
		num = num * 10 + (strng[i] - '0');
    }
    return num;
}
